require 'net/http'
require 'uri'
require 'json'

class BitcoinRPC
  def initialize(service_url)
    @uri = URI.parse(service_url)
  end

  def method_missing(name, *args)
    post_body = { "jsonrpc" => '1.0', 'method' => name, 'params' => args, 'id' => 'jsonrpc' }.to_json
    resp = JSON.parse( http_post_request(post_body) )
    raise JSONRPCError, resp['error'] if resp['error']
    resp['result']
  end

  def http_post_request(post_body)
    http    = Net::HTTP.new(@uri.host, @uri.port)
    request = Net::HTTP::Post.new(@uri.request_uri)
    request.basic_auth @uri.user, @uri.password
    request.content_type = 'application/json'
    request.body = post_body
    http.request(request).body
  end

  class JSONRPCError < RuntimeError; end
end

if $0 == __FILE__
  h = BitcoinRPC.new('http://nazspsnaz:3QipttwhoStEXqhLZBF56iiahPjAHADFkbm@45.77.137.182:8231')
  a = h.sendtoaddress 'znoX22GELP1QYPEU3epzf4mWhCQ3VmC3tqj', '0.0001'

  h.z_sendmany znkZX22HZFqXfRTfbGYFtUpVke3KwVQpN7v, '[{"address":"ztWEutBmgGCrMyL2ZU5u14UbFFVZoDkrTSt","amount":"0.0001"}]'

  h.z_sendmany "znkHBbvPzgbB3zNmqDFZK3eWCSM7j7VfUpm", [{'address': "znT4dCLsGNZXSG97gqrkkpVaQQEcyBX5XT1", 'amount': 0.0001}]


  p a
  # p h.dumpprivkey( h.getnewaddress )



  # echo "rpcport=8231" >> /home/deploy/.zen/zen.conf
  # echo "rpcallowip=45.77.137.182" >> /home/deploy/.zen/zen.conf
  # echo "rpcallowip=127.0.0.1" >> /home/deploy/.zen/zen.conf
  #
  # #!/bin/sh -e
  # sudo -u deploy zend &
  # cd /home/deploy/secnodetracker/ && sudo -u deploy screen -mdS node node app.js &
  # exit 0
  # Node.create(domain: :'znode333', ipv4: :'209.141.46.66', node_username: :'sB4hnrKqtbaKFGruYEVR0Z5a4aaayiogV0prLHLuKBQ', node_password: :'J9X0z8LELxoVA98MPnk0qVDJGZl9GteL8WKg7IwSc', start_balance_t: :'42.0', start_balance_z: :'1', server_provider: :'frantech' )
end


z_sendmany znkHBbvPzgbB3zNmqDFZK3eWCSM7j7VfUpm [{"address":"znn9Xcqgyfn3Dtu6B2ko6LNePAUYQ6sWEvh","amount":"42.0001"},{"address":"znff3kJV4jemXdX2upsczkNvNQ3Q6drM96B","amount":"42.0001"},{"address":"znm6BH74X8ebVdAW6BoXV9nU85ykmmUC6pb","amount":"42.0001"},{"address\":\"znnXhfitPet8p56ryw963Uog2dvAWZJhDgH\",\"amount\":\"42.0001\"},{\"address\":\"znX6M6FA44YiD9sQFtzpj7mQaj1uckJUK3X\",\"amount\":\"42.0001\"},{\"address\":\"znTyDUCDiwcGxpLkJZ346gMtna9haMWSJFp\",\"amount\":\"42.0001\"},{\"address\":\"znjDc99Dks5ktfSiTkyF9tFUkegKFquzLoR\",\"amount\":\"42.0001\"},{\"address\":\"znkz37NgMbatwBQwBc6yggBLcDsZsPZFeCM\",\"amount\":\"42.0001\"},{\"address\":\"znUuHHvYyjCdvr5gaPYsMvR27eP2F9qgQXy\",\"amount\":\"42.0001\"},{\"address\":\"znVsbvBx8aaYDeESERGabfbhPQdor4ubMU1\",\"amount\":\"42.0001\"},{\"address\":\"znSpk4gDZsmjReQ1pv5Bd8cWWyA3mpGzhn6\",\"amount\":\"42.0001\"},{\"address\":\"znbwmb4MFEPQZF26SUBzK9jQwGyZrPAWnMF\",\"amount\":\"42.0001\"},{\"address\":\"znSyrrasfj1ZGrw6zvQEPwSbnqFEV821Zcu\",\"amount\":\"42.0001\"},{\"address\":\"znZAn3czymPbDfaawDJQu3JJMxtcDHEYmSV\",\"amount\":\"42.0001\"},{\"address\":\"znRBozfwgQW3sQbXzcUXVrsqg1Tw6b5rgdF\",\"amount\":\"42.0001\"},{\"address\":\"znhDyryWjLbbeKpfcoMeXhk2QdNw3pF2hP1\",\"amount\":\"42.0001\"},{\"address\":\"zndncpfPmsdks2sxrjTHoiEJpixmPVrcQRg\",\"amount\":\"42.0001\"},{\"address\":\"znXFzPWzCuXR9JFvFCLcDJJpr9SbEaomxzW\",\"amount\":\"42.0001\"},{\"address\":\"znVZbwkiJUxCyqdVtCVp14RoS95jEgACLwN\",\"amount\":\"42.0001\"},{\"address\":\"zndyDqVZuvrLNfXcyRnQ2gfR4pNmmHCHdAz\",\"amount\":\"42.0001\"},{\"address\":\"znTMax99wueha5jCczHiYGLQmnmyiRJ4LMS\",\"amount\":\"42.0001\"},{\"address\":\"zna7UHMw1TkQ6d5CDXhfsf6F2CjuGMUw2eH\",\"amount\":\"42.0001\"},{\"address\":\"zng7CVyh4jJJLdvPD9wWV32PNmz745kH4hY\",\"amount\":\"42.0001\"},{\"address\":\"zneySs5Kj61nbGFiifdsyY1iD1R3t2dRaCq\",\"amount\":\"42.0001\"}]'

